extern "C" void hist2(double M[16], unsigned char g[], unsigned char f[], const int dg[3], const int df[3],
double H[65536], float s[3]);

#define NUM_THREADS 128
#define NUM_BLOCKS 256
//#include <math.h>
//#include "d:\cuda\include\math_functions.h"
//#include "C:\MATLAB08a\extern\include\mex.h"
//#include "D:\Program Files\MATLAB\R2009a\extern\include\mex.h"

//static int initialized=0;
static unsigned char *g_d,*f_d;
__shared__ double M1[16];
__device__ float samp_GPU(const int d[3], unsigned char f[], float x, float y, float z)
{
    int ix, iy, iz;
    float dx1, dy1, dz1, dx2, dy2, dz2;
    int k111,k112,k121,k122,k211,k212,k221,k222;
    float vf;
    unsigned char *ff;
    
    ix = floor(x); dx1=x-ix; dx2=1.0-dx1;
    iy = floor(y); dy1=y-iy; dy2=1.0-dy1;
    iz = floor(z); dz1=z-iz; dz2=1.0-dz1;
    
    ff   = f + ix-1+d[0]*(iy-1+d[1]*(iz-1));
    k222 = ff[   0]; k122 = ff[     1];
    k212 = ff[d[0]]; k112 = ff[d[0]+1];
    ff  += d[0]*d[1];
    k221 = ff[   0]; k121 = ff[     1];
    k211 = ff[d[0]]; k111 = ff[d[0]+1];
    
    vf = (((k222*dx2+k122*dx1)*dy2       +
    (k212*dx2+k112*dx1)*dy1))*dz2 +
    (((k221*dx2+k121*dx1)*dy2       +
    (k211*dx2+k111*dx1)*dy1))*dz1;
    return(vf);
}



__global__ void gpu_hist2(double M[16],  int data_size,float *s,unsigned char *g_d,unsigned char *f_d,const int *dg, const int *df,float *vf_d,unsigned char *ivf_d,unsigned char *ivg_d,bool *data_correct_d)

{
    const float ran[] = {0.656619,0.891183,0.488144,0.992646,0.373326,0.531378,0.181316,0.501944,0.422195,
    0.660427,0.673653,0.95733,0.191866,0.111216,0.565054,0.969166,0.0237439,0.870216,
    0.0268766,0.519529,0.192291,0.715689,0.250673,0.933865,0.137189,0.521622,0.895202,
    0.942387,0.335083,0.437364,0.471156,0.14931,0.135864,0.532498,0.725789,0.398703,
    0.358419,0.285279,0.868635,0.626413,0.241172,0.978082,0.640501,0.229849,0.681335,
    0.665823,0.134718,0.0224933,0.262199,0.116515,0.0693182,0.85293,0.180331,0.0324186,
    0.733926,0.536517,0.27603,0.368458,0.0128863,0.889206,0.866021,0.254247,0.569481,
    0.159265,0.594364,0.3311,0.658613,0.863634,0.567623,0.980481,0.791832,0.152594,
    0.833027,0.191863,0.638987,0.669,0.772088,0.379818,0.441585,0.48306,0.608106,
    0.175996,0.00202556,0.790224,0.513609,0.213229,0.10345,0.157337,0.407515,0.407757,
    0.0526927,0.941815,0.149972,0.384374,0.311059,0.168534,0.896648};
    const int tid = threadIdx.x;
    const int bid = blockIdx.x;
    const int idx = bid * blockDim.x + tid;
    float rx,ry,rz;
    float xp,yp,zp;
    float xx_temp,yy_temp,zz_temp;
    int x_datasize,y_datasize;
    x_datasize=(dg[0]-2)/s[0];
    y_datasize=(dg[1]-2)/s[1];
    
    if (tid==0)
        
    {
        
     for (int ii=0;ii<16;ii++)
         M1[ii]=M[ii];
    }
    if (idx<data_size)
    {
        for(int ii = idx; ii < data_size; ii += NUM_THREADS*NUM_BLOCKS)
        {
            
            
            xx_temp=(ii%x_datasize)*s[0]+1;
            yy_temp=((int)floor((float)(ii/x_datasize))%y_datasize)*s[1]+1;
            zz_temp=floor(floor((float)(ii/x_datasize))/y_datasize)*s[2]+1;
            
            rx  = xx_temp + ran[idx%97]*s[0]; //I actually don't know why we need to add this random number
            ry  = yy_temp + ran[idx%97]*s[1];
            rz  = zz_temp + ran[idx%97]*s[2];
            
            xp  = M1[0]*rx + M1[4]*ry + M1[ 8]*rz + M1[12];
            yp  = M1[1]*rx + M1[5]*ry + M1[ 9]*rz+ M1[13];
            zp  = M1[2]*rx + M1[6]*ry + M1[10]*rz+ M1[14];
            
            if (zp>=1.0 && zp<df[2] && yp>=1.0 && yp<df[1] && xp>=1.0 && xp<df[0])
            {
                //vf_d[ii]  = samp_GPU(df, f_d, xp,yp,zp);
                ivf_d[ii] = floor(samp_GPU(df, f_d, xp,yp,zp)+0.5);
                ivg_d[ii] = floor(samp_GPU(dg, g_d, rx,ry,rz)+0.5);
                // vf_d[ii]=vf_d[ii]-ivf_d[ii];
                    data_correct_d[ii]=1;
            }
            else
            {
                data_correct_d[ii]=0;
                vf_d[ii]  = 0;
                ivf_d[ii] = 0;
                ivg_d[ii] = 0;
            }
            
            
            
            
        }
    }
    
}




void hist2(double M[16], unsigned char g[], unsigned char f[], const int dg[3], const int df[3],
double H[65536], float s[3])
{
    
    
    
    
    
    double *M_d;
    cudaSetDevice(1);
    cudaMalloc((void**)&M_d,16*sizeof(double));
    cudaMemcpy(M_d,M,16*sizeof(double),cudaMemcpyHostToDevice);
    //cudaMemcpy(M1,M,16*sizeof(double),cudaMemcpyHostToDevice);
    
    
    
    float *s_d;
    cudaMalloc((void**)&s_d,3*sizeof(float));
    cudaMemcpy(s_d,s,3*sizeof(float),cudaMemcpyHostToDevice);
    
    int data_size;
    data_size=dg[0]*dg[1]*dg[2]/s[0]/s[1]/s[0];
    
 //   if (!initialized)
 //   {
        
        
        cudaMalloc((void**)&g_d,dg[0]*dg[1]*dg[2]*sizeof(unsigned char));
        cudaMalloc((void**)&f_d,df[0]*df[1]*df[2]*sizeof(unsigned char));
        
        cudaMemcpy(g_d,g,dg[0]*dg[1]*dg[2]*sizeof(unsigned char),cudaMemcpyHostToDevice);
        cudaMemcpy(f_d,f,df[0]*df[1]*df[2]*sizeof(unsigned char),cudaMemcpyHostToDevice);
   //     initialized=1;
        //    mexPrintf("MEX-file initializing, creating GPU array and setting a value.\n");
 //   }else
        
  //  {
        // do nothing
        //   mexPrintf("MEX-file reuse GPU memory\n");
 //   }
    
    
    int *dg_d,*df_d; //data size of g and f
    cudaMalloc((void**)&dg_d,3*sizeof(int));
    cudaMalloc((void**)&df_d,3*sizeof(int));
    
    cudaMemcpy(dg_d,dg,3*sizeof(int),cudaMemcpyHostToDevice);
    cudaMemcpy(df_d,df,3*sizeof(int),cudaMemcpyHostToDevice);
    
    float *vf_d;
    unsigned char  *ivf_d, *ivg_d;
    cudaMalloc((void**)&vf_d,data_size*sizeof(float));
    cudaMalloc((void**)&ivf_d,data_size*sizeof(unsigned char));
    cudaMalloc((void**)&ivg_d,data_size*sizeof(unsigned char));
    
    bool *data_correct_d;
    cudaMalloc((void**)&data_correct_d,data_size*sizeof(bool));
    
    
    
    gpu_hist2<<<NUM_BLOCKS,NUM_THREADS>>>(M_d, data_size,s_d,g_d,f_d,dg_d,df_d,vf_d,ivf_d,ivg_d,data_correct_d);
    
    
    float *vf_h;
    unsigned char  *ivf_h, *ivg_h;
    bool *data_correct_h;
    
    vf_h= (float *)malloc(data_size*sizeof(float));
    ivf_h= (unsigned char *)malloc(data_size*sizeof(unsigned char));
    ivg_h=(unsigned char *)malloc(data_size*sizeof(unsigned char));
    
    data_correct_h=(bool *)malloc(data_size*sizeof(bool));
    //   cudaMemcpy(vf_h,vf_d,data_size*sizeof(float),cudaMemcpyDeviceToHost);
    cudaMemcpy(ivf_h,ivf_d,data_size*sizeof(unsigned char),cudaMemcpyDeviceToHost);
    cudaMemcpy(ivg_h,ivg_d,data_size*sizeof(unsigned char),cudaMemcpyDeviceToHost);
    cudaMemcpy(data_correct_h,data_correct_d,data_size*sizeof(bool),cudaMemcpyDeviceToHost);
    
    // unsigned char ivf_temp;
    for(int ii = 0; ii < data_size; ii ++)
    {
        if (data_correct_h[ii])
        H[ivf_h[ii]+ivg_h[ii]*256] += 1;    
    }
    
    
    free(vf_h);free(ivf_h);free(ivg_h);free(data_correct_h);
    cudaFree(M_d);cudaFree(s_d);
    cudaFree(dg_d);cudaFree(df_d);
    cudaFree(vf_d);cudaFree(ivf_d);cudaFree(ivg_d);
    cudaFree(data_correct_d);
    
    
}






